; Fur + Real Phong shading implemented if flat assembler
; by Maciej Guba.
; http://macgub.vxm.pl


ROUND2 equ 10
FUR_SHIFT = 9
FUR_SIZEXY = 512
FUR_SIZE = 512*512
FUR_SHELLS = 8
fur_phong_tri_z:
;----Procedure render Phongs shaded triangle with -------
;----arbitrary color given and fur effect.---------------
;----I normalize normal vector in every pixel -----------
;------in - eax - x1 shl 16 + y1 ------------------------
;---------- ebx - x2 shl 16 + y2 ------------------------
;---------- ecx - x3 shl 16 + y3 ------------------------
;---------- edx - ptr to fur coords struct---------------
;---------- esi - pointer to Z-buffer filled ------------
;--------------   with dword float variables ------------
;---------- edi - pointer to screen buffer --------------
;---------- xmm0 - 1st normal vector --------------------
;---------- xmm1 - 2cond normal vector ------------------
;---------- xmm2 - 3rd normal vector --------------------
;---------- xmm3 - --------------------------------------
;---------- xmm6 - fur shells ptr -----------------------
;---------- xmm4 - lo -> hi z1, z2, z3 coords -----------
;---------------   as dwords floats ---------------------
;---------- xmm5 - lo -> hi y_min, y_max, x_min, x_max --
;---------------   as dword integers --------------------
;---------------------- stack - no parameters -----------
;--------------------------------------------------------
;----------------- procedure don't save registers !! ----


  .fx1 equ [edx]       ; fur maps coordinates
  .fy1 equ [edx+4]     ; [edx] adress should be aligned
  .fx2 equ [edx+8]     ; all fur params as dword float
  .fy2 equ [edx+12]
  .fx3 equ [edx+16]
  .fy3 equ [edx+20]





  push  ebp
  mov   ebp,esp
  sub   esp,1024
  sub   ebp,16
  and   ebp,0xfffffff0

  .1_nv equ [ebp-16]
  .2_nv equ [ebp-32]
  .3_nv equ [ebp-48]
  .l_v  equ [ebp-64]
  .z3   equ [ebp-72]
  .z2   equ [ebp-76]
  .z1   equ [ebp-80]
  .x1   equ [ebp-82]
  .y1   equ [ebp-84]
  .x2   equ [ebp-86]
  .y2   equ [ebp-88]
  .x3   equ [ebp-90]
  .y3   equ [ebp-92]
  .Zbuf equ [ebp-96]
  .x_max  equ [ebp-100]
  .x_min  equ [ebp-104]
  .y_max  equ [ebp-108]
  .y_min  equ [ebp-112]
  .screen equ [ebp-116]
  .dx12   equ [ebp-120]
  .dx13   equ [ebp-124]
  .dx23   equ [ebp-128]
  .dn12   equ [ebp-144]
  .dn13   equ [ebp-160]
  .dn23   equ [ebp-176]
  .dz12   equ [ebp-180]
  .dz13   equ [ebp-184]
  .dz23   equ [ebp-188]
  .cnv1   equ [ebp-208] ; current normal vectors
  .cnv2   equ [ebp-240]
  .cz2    equ [ebp-244]
  .cz1    equ [ebp-248]
  .fur_coor_ptr equ [ebp-252]   ; fur coords ptr
  .fur_sh_ptr   equ [ebp-256]   ; fur shells ptr

  .fyc1    equ [ebp-256-4]     ; cur fur coords both x and y
  .fxc1    equ [ebp-256-8]
  .fyc2    equ [ebp-256-4*3]
  .fxc2    equ [ebp-256-4*4]
  .fyd12   equ [ebp-256-4*5]  ; delta fur 'a' layer x and y
  .fxd12   equ [ebp-256-4*6]
  .fyd13   equ [ebp-256-4*7]
  .fxd13   equ [ebp-256-4*8]
  .fyd23   equ [ebp-256-4*9]
  .fxd23   equ [ebp-256-4*10]


      movd     .fur_sh_ptr,xmm6
 .sort3:                  ; sort triangle coordinates...
       cmp     ax,bx
       jle     .sort1
       xchg    eax,ebx
       shufps  xmm4,xmm4,11100001b
       movaps  xmm6,xmm0
       movaps  xmm0,xmm1
       movaps  xmm1,xmm6
       movaps  xmm7,.fx1
       shufps  xmm7,xmm7,01001110b
       movaps  .fx1,xmm7

 .sort1:
       cmp      bx,cx
       jle      .sort2
       xchg     ebx,ecx
       shufps   xmm4,xmm4,11011000b
       movaps   xmm6,xmm1
       movaps   xmm1,xmm2
       movaps   xmm2,xmm6
       movups   xmm7,.fx2
       shufps   xmm7,xmm7,01001110b
       movups   .fx2,xmm7

       jmp .sort3

 .sort2:

   movaps .z1,xmm4
   mov    .y1,eax
   mov    .y2,ebx
   mov    .y3,ecx

   movdqa   .y_min,xmm5
if 1                            ; check if at last only fragment
   packssdw xmm5,xmm5       ; of triangle is in visable area
   pshuflw  xmm5,xmm5,11011000b
   movdqu   xmm7,.y3
   movdqa   xmm6,xmm5
   pshufd   xmm5,xmm5,0  ; xmm5 lo-hi -> broadcasted y_min, x_min
   pshufd   xmm6,xmm6,01010101b ;xmm6 -> brd y_max x_max
   movdqa   xmm4,xmm7
   pcmpgtw  xmm7,xmm5
   pcmpgtw  xmm4,xmm6
   pxor     xmm7,xmm4
   pmovmskb eax,xmm7
   and      eax,0x00aaaaaa
   or       eax,eax
   jz       .rpt_loop2_end
end if
   movaps   .1_nv,xmm0
   movaps   .2_nv,xmm1
   movaps   .3_nv,xmm2
 ;  movaps   .l_v,xmm3
   mov      .Zbuf,esi
   mov      .screen,edi
   mov      .fur_coor_ptr,edx



       mov      bx,.y2       ; calc deltas
       sub      bx,.y1
       jnz      .rpt_dx12_make

       xorps    xmm7,xmm7
       mov      dword .dx12,0
       mov      dword .dz12,0
       movaps   .dn12,xmm7
       movlps   .fxd12,xmm7
       jmp      .rpt_dx12_done

  .rpt_dx12_make:
       mov      ax,.x2
       sub      ax,.x1
       cwde
       movsx    ebx,bx
       shl      eax,ROUND2
       cdq
       idiv     ebx
       mov      .dx12,eax

       cvtsi2ss xmm6,ebx
       movss    xmm5,.z2
       rcpss    xmm6,xmm6
       subss    xmm5,.z1
       mulss    xmm5,xmm6
       movss    .dz12,xmm5

       shufps   xmm6,xmm6,0
       movaps   xmm0,.2_nv
       subps    xmm0,.1_nv
       mulps    xmm0,xmm6
       movaps   .dn12,xmm0
       mov      edx,.fur_coor_ptr
       movlps   xmm0,.fx1
       movlps   xmm3,.fx2
       subps    xmm3,xmm0
       mulps    xmm3,xmm6
       movlps   .fxd12,xmm3

   .rpt_dx12_done:
       mov      bx,.y3       ; calc deltas
       sub      bx,.y1
       jnz      .rpt_dx13_make

       xorps    xmm7,xmm7
       mov      dword .dx13,0
       mov      dword .dz13,0
       movaps   .dn13,xmm7
       movlps   .fxd13,xmm7
       jmp      .rpt_dx13_done

  .rpt_dx13_make:
       mov      ax,.x3
       sub      ax,.x1
       cwde
       movsx    ebx,bx
       shl      eax,ROUND2
       cdq
       idiv     ebx
       mov      .dx13,eax

       cvtsi2ss xmm6,ebx
       movss    xmm5,.z3
       rcpss    xmm6,xmm6
       subss    xmm5,.z1
       mulss    xmm5,xmm6
       movss    .dz13,xmm5

       movaps   xmm0,.3_nv
       subps    xmm0,.1_nv
       shufps   xmm6,xmm6,0
       mulps    xmm0,xmm6
       movaps   .dn13,xmm0
       mov      edx,.fur_coor_ptr
       movlps   xmm0,.fx1
       subps    xmm0,.fx3
       mulps    xmm0,xmm6
       movlps   .fxd13,xmm0

  .rpt_dx13_done:

       mov      bx,.y3       ; calc deltas
       sub      bx,.y2
       jnz      .rpt_dx23_make

       xorps    xmm7,xmm7
       mov      dword .dx23,0
       mov      dword .dz23,0
       movaps   .dn23,xmm7
       movlps   .fxd23,xmm7

       jmp      .rpt_dx23_done

  .rpt_dx23_make:
       mov      ax,.x3
       sub      ax,.x2
       cwde
       movsx    ebx,bx
       shl      eax,ROUND2
       cdq
       idiv     ebx
       mov      .dx23,eax

       cvtsi2ss xmm6,ebx
       movss    xmm5,.z3
       rcpss    xmm6,xmm6
       subss    xmm5,.z2
       mulss    xmm5,xmm6
       movss    .dz23,xmm5

       movaps   xmm0,.3_nv
       subps    xmm0,.2_nv
       shufps   xmm6,xmm6,0
       mulps    xmm0,xmm6
       movaps   .dn23,xmm0
       mov      edx,.fur_coor_ptr
       movlps   xmm0,.fx2
       subps    xmm0,.fx3
       mulps    xmm0,xmm6
       movlps   .fxd23,xmm0

   .rpt_dx23_done:

       movsx   eax,word .x1
       shl     eax,ROUND2
       mov     ebx,eax
       mov     ecx,.z1
       mov     .cz1,ecx
       mov     .cz2,ecx
       movaps  xmm0,.1_nv
       mov     edx,.fur_coor_ptr
       movlps  xmm1,.fx1
       movaps  .cnv1,xmm0
       movaps  .cnv2,xmm0
       movlps  .fxc1,xmm1
       movlps  .fxc2,xmm1
       lea      edx,.fxc2 ; fur coord params as reference
       mov      edi,.screen
       mov      esi,.Zbuf
       movsx    ecx,word .y1
       cmp      cx,.y2

       jge      .rpt_loop1_end

    .rpt_loop1:
       pushad

       movaps   xmm2,.y_min
       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       movlps   xmm3,.cz1
       movaps   xmm4,.l_v
       movd     xmm5,.fur_sh_ptr    ; fur shells
       movaps   xmm6,.fxc2
       sar      ebx,ROUND2
       sar      eax,ROUND2

       call     fur_real_phong_line_z

       popad
       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       ; fur x,y
       movaps   xmm4,.fxc2
       movss    xmm2,.cz1
       movss    xmm3,.cz2
       shufps   xmm4,xmm4,01001110b
       addps    xmm0,.dn13
       addps    xmm1,.dn12
       addss    xmm2,.dz13
       addss    xmm3,.dz12
       addps    xmm4,.fxd13


       add      eax,.dx13
       add      ebx,.dx12

       shufps   xmm4,xmm4,01001110b
       movaps   .cnv1,xmm0
       movaps   .cnv2,xmm1
       movss    .cz1,xmm2
       movss    .cz2,xmm3
       movaps   .fxc2,xmm4   ; fur x,y

       add      ecx,1
       cmp      cx,.y2
       jl       .rpt_loop1


   .rpt_loop1_end:
       movsx    ecx,word .y2
       cmp      cx,.y3
       jge      .rpt_loop2_end

       movsx    ebx,word .x2               ; eax - cur x1
       shl      ebx,ROUND2                 ; ebx - cur x2
       push     dword .z2
       pop      dword .cz2
       mov      edx,.fur_coor_ptr
       movaps   xmm0,.2_nv
       movq     xmm1,.fx2
       movaps   .cnv2,xmm0
       movq     .fxc2,xmm1

       mov      edi,.screen
       mov      esi,.Zbuf


     .rpt_loop2:
       pushad
       movaps   xmm2,.y_min
       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       movlps   xmm3,.cz1
       movaps   xmm4,.l_v
       movd     xmm5,.fur_sh_ptr
       movaps   xmm6,.fxc2
       sar      ebx,ROUND2
       sar      eax,ROUND2

       call     fur_real_phong_line_z

       popad
       movaps   xmm0,.cnv1
       movaps   xmm1,.cnv2
       movhps   xmm4,.fxc2
       movhps   xmm6,.fxd23
       movlps   xmm4,.fxc1   ; fur x,y - a and b
       movlps   xmm6,.fxd13
       movss    xmm2,.cz1
       movss    xmm3,.cz2

       addps    xmm0,.dn13
       addps    xmm1,.dn23
       addss    xmm2,.dz13
       addss    xmm3,.dz23
       add      eax,.dx13
       add      ebx,.dx23
       addps    xmm4,xmm6

       movaps   .cnv1,xmm0
       movaps   .cnv2,xmm1
       movss    .cz1,xmm2
       movss    .cz2,xmm3
       movlps   .fxc1,xmm4   ; fur x,y
       movhps   .fxc2,xmm4

       add      ecx,1
       cmp      cx,.y3
       jl       .rpt_loop2

    .rpt_loop2_end:

      add   esp,1024
      pop   ebp

ret
align 16
fur_real_phong_line_z:
; in:
;    xmm0 - normal vector 1
;    xmm1 - normal vect 2
;    xmm3 - lo -> hi z1, z2 coords as dwords floats
;    xmm2 - lo -> hi y_min, y_max, x_min, x_max
;           as dword integers
;    xmm4 - ----
;    xmm5 - ptr to fur shells
;    xmm6 - lo -> hi fur x2 ,y2, x1, y1 coords as dword float
;    eax - x1
;    ebx - x2
;    ecx - y
;    edx - -----
;    edi - screen buffer
;    esi - z buffer filled with dd floats

   push  ebp
   mov   ebp,esp
   sub   esp,256
   sub   ebp,16
   and   ebp,0xfffffff0

 .n1  equ [ebp-16]
 .n2  equ [ebp-32]
 .lv  equ [ebp-48]
 .lx1 equ [ebp-52]
 .lx2 equ [ebp-56]
 .z2  equ [ebp-60]
 .z1  equ [ebp-64]
 .screen equ [ebp-68]
 .zbuff  equ [ebp-72]
 .x_max  equ [ebp-74]
 .x_min  equ [ebp-76]
 .y_max  equ [ebp-78]
 .y_min  equ [ebp-80]
 .dn     equ [ebp-96]
 .dz     equ [ebp-100]
 .y      equ [ebp-104]
 .cnv    equ [ebp-128]
 .fshl_ptr equ [ebp-144]
 .fcury    equ [ebp-152]
 .fcurx    equ [ebp-160]
 .fy1      equ [ebp-164]
 .fx1      equ [ebp-168]     ;fur parameters
 .fy2      equ [ebp-172]
 .fx2      equ [ebp-176]
 .dfy      equ [ebp-180]
 .dfx      equ [ebp-184] ; delta x, y coords of  fur shells
 .y_mn     equ [ebp-196]
 .x_mn     equ [ebp-196-4]
 .y_mx     equ [ebp-196-8]
 .x_mx     equ [ebp-196-12]
 .yf       equ [ebp-208-4]
 .xf       equ [ebp-216]
; .czf    equ [ebp-176-(16*7)+8]
; .cy    equ [ebp-176-(16*7)+4]
; .cx    equ [ebp-176-(16*7)]
; .dzf    equ [ebp-176-(16*8)+8]
; .dy    equ [ebp-176-(16*8)+4]
; .dx    equ [ebp-176-(16*8)]


        mov     .y,ecx
        movdqa   xmm4,xmm2
        packssdw xmm2,xmm2
        movq    .y_min,xmm2
        cmp     cx,.y_min
        jl      .end_rp_line
        cmp     cx,.y_max
        jge     .end_rp_line          ;
        cmp     eax,ebx
        je      .end_rp_line
        pshufd  xmm4,xmm4,00100111b
        paddd   xmm4,[margin3fur]
        movdqa  .x_mx,xmm4
        jl      @f
        xchg    eax,ebx
        movaps  xmm7,xmm0
        shufps  xmm6,xmm6,01001110b
        movaps  xmm0,xmm1
        movaps  xmm1,xmm7
        shufps  xmm3,xmm3,11100001b
        movaps  .fx2,xmm6
    @@:
        cmp     ax,.x_max
        jge     .end_rp_line
        cmp     bx,.x_min
        jle     .end_rp_line
     ;   movaps  .lv,xmm4
        andps    xmm0,[zero_hgst_dd]
        andps    xmm1,[zero_hgst_dd]
        movaps  .n1,xmm0
        movaps  .n2,xmm1
        movaps  .fx2,xmm6
        mov     .lx1,eax
        mov     .lx2,ebx
        movlps  .z1,xmm3
        movd     .fshl_ptr,xmm5




        sub     ebx,eax
        cvtsi2ss xmm7,ebx
        rcpss   xmm7,xmm7
        shufps  xmm7,xmm7,0
        subps   xmm1,xmm0
        mulps   xmm1,xmm7
        movaps  .dn,xmm1
        shufps  xmm3,xmm3,11111001b
        subss   xmm3,.z1
        mulss   xmm3,xmm7
        movss   .dz,xmm3

        movlps  xmm6,.fx2   ;calc fur deltas
        movlps  xmm5,.fx1
        subps   xmm6,xmm5
        mulps   xmm6,xmm7
        movlps  .dfx,xmm6

        mov      ebx,.lx1
        cmp      bx,.x_min     ; clipping on function4
        jge      @f
        movzx    eax,word .x_min
        sub      eax,ebx
        cvtsi2ss xmm7,eax
        shufps   xmm7,xmm7,0
        mulss    xmm3,xmm7
        mulps    xmm1,xmm7
        mulps    xmm6,xmm7
        movlps   xmm5,.fx1
        addss    xmm3,.z1
        addps    xmm1,.n1
        addps    xmm6,xmm5

        movsx    eax,word .x_min
        movss    .z1,xmm3
        movaps   .n1,xmm1
        movlps   .fx1,xmm6
        mov      dword .lx1,eax

      @@:
        movzx   eax,word .x_max
        cmp     .lx2,eax
        jl      @f
        mov     .lx2,eax
      @@:
        movzx   eax,word[xres_var]
        mul     dword .y
        add     eax,.lx1
        mov     .zbuff,esi
        mov     .screen,edi
        shl     eax,2
        add     edi,eax
        add     esi,eax

        mov     ecx,.lx2
        sub     ecx,.lx1

     ;   movq2dq   xmm3,mm0
     ;   punpcklbw xmm3,[the_zero]
     ;   punpcklwd xmm3,[the_zero]
     ;   cvtdq2ps  xmm3,xmm3
     ;   movaps    .col,xmm3
;        cvtsi2ss xmm0,.lx1
;        push    .z1
;        pop     .czf
;        cvtsi2ss xmm2,.y
;        movss   .cxf,xmm0
;        movss   .cyf,xmm2
;        mov     .dxf,dword 1.0
;        mov     .dyf,dword 0

        movaps  xmm0,.n1
        movss   xmm2,.z1
align 16
   .ddraw:
        movss    xmm7,xmm2
        cmpnltss xmm7,dword[esi]
        movd     eax,xmm7
        or       eax,eax
        jnz      .skip
        movss    [esi],xmm2
        movaps   xmm7,xmm0
        mulps    xmm7,xmm7 ; normalize
        haddps   xmm7,xmm7
        haddps   xmm7,xmm7
        rsqrtps  xmm7,xmm7
        mulps    xmm7,xmm0
        movaps   .cnv,xmm7

        mov      edx,lights_aligned    ; lights - global variable
        xorps    xmm1,xmm1     ; instead global can be used .lv - light vect.
        align 16
      @@:
        movaps    xmm5,[edx]
        andps     xmm5,[zero_hgst_dd]  ; global

        mulps    xmm5,.cnv  ;.lv  ; last dword should be zeroed
        haddps   xmm5,xmm5
        haddps   xmm5,xmm5
   ;     mulps    xmm5,[env_const2]
   ;     maxps    xmm5,[dot_min]
   ;     minps    xmm5,[dot_max]
        movaps   xmm7,xmm5
      ;  mulps    xmm7,[env_const2]
     ;   mulps    xmm7,[env_const2]
     ;   maxps    xmm7,[dot_min]
     ;   minps    xmm7,[dot_max]

        mulps    xmm7,xmm7
        mulps    xmm7,xmm7
        mulps    xmm5,[edx+16]  ;xmm6
        mulps    xmm7,xmm7
        mulps    xmm7,[edx+48]   ;xmm3

        addps    xmm5,xmm7
     ;   mulps    xmm5,.col

        minps    xmm5,[mask_255f]  ; global
        maxps    xmm1,xmm5
     ;   movq     xmm3,[edx+20]    ; minimal color
     ;   punpcklwd xmm3,[minimum0]
     ;   cvtdq2ps xmm3,xmm3
     ;   maxps    xmm1,xmm3
        add      edx,64
        cmp      edx,lights_aligned_end    ; global
        jnz      @b
    ;    movq2dq   xmm3,mm0
    ;    punpcklbw xmm3,[the_zero]
    ;    punpcklwd xmm3,[the_zero]
    ;    cvtdq2ps  xmm3,xmm3
    ;    mulps    xmm1,xmm3
    ;    mulps    xmm1,.col
        cvtps2dq  xmm1,xmm1
        packssdw  xmm1,xmm1
      ;  psrlw     xmm1,8
        packuswb  xmm1,xmm1
      ;  int3
        movd      [edi],xmm1
        punpcklbw   xmm1,[the_zero]

      ;fur work
    ;    int3
        push      ecx
        push      esi
        movlps    xmm4,.fx1
        maxps     xmm4,[the_zero]
        cvttps2dq xmm4,xmm4
        movd      esi,xmm4
        movdqa    xmm3,xmm4
        psrldq    xmm4,4
        movd      eax,xmm4
        shl       eax,FUR_SHIFT
        add       esi,eax
        add       esi,.fshl_ptr
        mov       ecx,1
      .fr:
        cmp       byte[esi],0
        jz        @f

        mov       eax,ecx
   ;     neg       eax
   ;     and       eax,0x11
        shl       eax,2
        cvtsi2ss  xmm3,eax
        shufps    xmm3,xmm3,11000000b
        mulps     xmm3,.cnv
      ;  movaps    xmm4,xmm3   ; neg z cooficient
      ;  andnps    xmm4,xmm4
      ;  andps     xmm3,[and_msk_z_cord_neg]  ; zero z coof
      ;  andps     xmm4,[and_msk_z_cord]
      ;  orps      xmm3,xmm4
        movhlps   xmm4,xmm3
        cvtps2dq  xmm3,xmm3
        movd      eax,xmm3
        psrldq    xmm3,4
        movd      ebx,xmm3
        add       eax,.lx1
        add       ebx,.y
        mov       .xf,eax
        mov       .yf,ebx
        movq      mm7,.xf
        movq      mm3,.xf
        movdqa    xmm3,.x_mx
     ;   int3
        pcmpgtd   mm7,.x_mx
        pcmpgtd   mm3,.x_mn
        pxor      mm3,mm7
        pmovmskb  eax,mm3
        and       eax,0xff
        cmp       eax,0xff
        jne       @f
        movzx     edx,[xres_var]
        imul      ebx,edx
        add       ebx,.xf
        shl       ebx,2
        mov       eax,ebx
      ;  movaps    xmm3,xmm2
        addss     xmm4,xmm2    ; xmm2 - cur z
        movaps    xmm3,xmm4
        add       ebx,.zbuff
  ;      comiss    xmm4,[ebx]
        cmpltss   xmm4,dword[ebx]
        movd      edx,xmm4
        or        edx,edx
        jz        @f
        add        eax,.screen
        movss     [ebx],xmm3
        movzx     ebx,byte[esi]
        shl       ebx,5
        mov       [eax],ebx
      @@:
        add       esi,FUR_SIZE
        inc       ecx
        cmp       ecx,FUR_SHELLS
        jnz       .fr

        pop       esi
        pop       ecx


      ;   movd     [edi],xmm1
     .skip:
        movlps   xmm6,.fx1
        movlps   xmm7,.dfx
     ;   movaps   xmm5,.cxf
        add      edi,4
        add      esi,4
        add      dword .lx1,1
        addps    xmm6,xmm7
        addps    xmm0,.dn
        addss    xmm2,.dz
        movlps   .fx1,xmm6

        sub      ecx,1
        jnz      .ddraw

  .end_rp_line:
        add      esp,256
        pop      ebp

ret
fur_shell_generator:
  ; in ecx - fur size
  ;    edi - fur ptr
  ;    esi - shels count
  ; each hair 'strand' of fur as byte
  push  ebp
  mov   ebp,esp
  sub   esp,10
  mov   edx,esi
  inc   edx
.lp:
  mov   [rand_seed],0x83a4
  push  ecx
@@:
  push  edx
  push  ecx
  push  edi
  push  esi
  mov   ecx,0
  mov   edx,5
  sub   edx,esi
  call  random
  pop   esi
  pop   edi
  pop   ecx
  pop   edx
  mov   byte[edi],al
  add   edi,1
  loop  @b
  pop   ecx
  dec   esi
  jnz   .lp
if 0
 .ag:            ; filter
  push  ecx
  push  edi
  mov   ecx,0
  mov   edx,7
  call  random
  pop   edi
  pop   ecx
  cmp   eax,1
  je    @f
  mov   byte[edi],0
@@:
  add   edi,1
  loop  .ag
end if
  mov   esp,ebp
  pop   ebp
ret