draw_th0:
  xor eax,eax
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,0
ret

draw_th1:
  mov eax,1
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,0  ;1
ret

draw_th2:
  mov  eax,2
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,0  ;2
ret

draw_th3:
  mov  eax,3
  call draw_thread
  invoke SendMessage,hwnd,WM_FINISH,0,0
  invoke ExitThread,0  ;3
ret



draw_thread:    ; in: eax - thread number; 0 - first thread
    push   ebp
    mov    ebp,esp
    sub    esp,256
    and    ebp,-16



    .thread_no equ dword[ebp-4]
    .x_min     equ word[ebp-6]
    .x_max     equ word[ebp-8]
    .y_min     equ word[ebp-10]
    .y_max     equ [ebp-12]

    .third_p_index  equ dword[ebp-16]
    .second_p_index equ dword[ebp-20]
    .first_p_index  equ dword[ebp-24]

   .zz1f equ dword[ebp-28]
   .zz2f equ dword[ebp-32]
   .zz3f equ [ebp-36]
   .xy3  equ ebp-40
   .xy2  equ ebp-44
   .xy1  equ ebp-48
   .zz3  equ [ebp-52]
   .zz2  equ [ebp-54]
   .zz1  equ [ebp-56]

   .x_temp_var equ dword [ebp-112]
   .y_temp_var equ dword [ebp-116]
   .counter    equ dword [ebp-120]


    mov    .thread_no,eax
    cmp    [draw_flag],9
    jl     @f
    cmp    [draw_flag],10  ; flat draw float cause
    je     @f
    cmp    [draw_flag],15  ; phong shd
    jge    .ph
  ;  cmp    [draw_flag],18
  ;  je     @f
  ;  cmp    [draw_flag],16  ; phong shd + tex bil filtering
  ;  je     .ph

    cmp    [draw_flag],14
    je     .draw_vertices
    push   [yres_var]
    pop    word .y_max
    mov    .y_min,0
    push   [xres_var]
    pop    .x_max
    mov    .x_min,0
;    cmp     [draw_flag],16
;    je     .skip_div
;    cmp     [draw_flag],17
;    je     .skip_div
    jmp    .draw_edges
  @@:
    movzx  ebx,[yres_var]
    shr    ebx,1   ; shr ebx,n ;n=1 - 2 threads, n=2 - 4 threads...
    mov    ecx,ebx
    imul   ebx,eax
    mov    .y_min,bx
    add    ebx,ecx
    mov    .y_max,bx
    jmp    .skip_div
  .ph:
    movzx  ebx,[yres_var]
    shr    ebx,1   ; shr ebx,n ;n=1 - 2 threads, n=2 - 4 threads...
    movzx  edx,[xres_var]
    shr    edx,1
    cmp    eax,0
    jne    @f
    mov    .y_min,0
    mov    .x_min,0
    mov    .y_max,bx
    mov    .x_max,dx
    jmp    .skip_div
   @@:
    cmp    eax,1
    jne    @f
    mov    .y_min,0
    mov    .x_min,dx
    push    [xres_var]
    pop    .x_max
    mov    .y_max,bx
    jmp    .skip_div
   @@:
    cmp    eax,2
    jne    @f
    push   [yres_var]
    pop    word .y_max
    mov    .y_min,bx
    mov    .x_min,0
    mov    .x_max,dx
    jmp    .skip_div
  @@:
    cmp    eax,3
    jne    @f
    push   [yres_var]
    pop    word .y_max
    mov    .y_min,bx
    mov    .x_min,dx
    push   [xres_var]
    pop    .x_max
   ; jmp    .skip_div
  @@:
  .skip_div:




    mov   esi,[triangles_ptr]            ; draw triangles
    xor   ecx,ecx
 ;   mov   ecx,[triangles_count_var]
  .draw_triangle:
    push  ecx
    push  esi
    pushad
    fninit
    cmp      [culling_flag],1
    je       @f
    imul     ecx,[i12]
    add      ecx,[triangles_normals_rotated_ptr]
    movups   xmm0,[ecx]
    movmskps eax,xmm0
    and      eax,100b
    cmp      eax,000b
    je       .end_draw
  @@:
    mov   edx,dword[esi]
    mov   eax,dword[esi+4]
    mov   ebx,dword[esi+8]
    shl   edx,2
    shl   eax,2
    shl   ebx,2
    lea   edx,[edx*3]
    lea   eax,[eax*3]
    lea   ebx,[ebx*3]
    mov   .first_p_index,edx
    mov   .second_p_index,eax
    mov   .third_p_index,ebx
    add   edx,[points_rotated_ptr]
    add   eax,[points_rotated_ptr]
    add   ebx,[points_rotated_ptr]
    movlps xmm0,[edx]
    movlps xmm1,[eax]
    movlps xmm2,[ebx]

    shufps xmm0,xmm0,11100001b
    shufps xmm1,xmm1,11100001b
    shufps xmm2,xmm2,11100001b

    cvtps2dq xmm0,xmm0
    cvtps2dq xmm1,xmm1
    cvtps2dq xmm2,xmm2
    packssdw xmm0,xmm0
    packssdw xmm1,xmm1
    packssdw xmm2,xmm2
    movd     [.xy1],xmm0
    movd     [.xy2],xmm1
    movd     [.xy3],xmm2


    movss  xmm3,[edx+8]
    movss  xmm4,[eax+8]
    movss  xmm5,[ebx+8]
    movss  .zz1f,xmm3
    movss  .zz2f,xmm4
    movss  .zz3f,xmm5
    cvtps2dq  xmm3,xmm3
    cvtps2dq  xmm4,xmm4
    cvtps2dq  xmm5,xmm5
    movd     .zz1,xmm3
    movd     .zz2,xmm4
    movd     .zz3,xmm5









    cmp   [draw_flag],1
    je    .flat_draw

    cmp   [draw_flag],3
    je    .env_mapping
    cmp   [draw_flag],4
    je    .bump_mapping
    cmp   [draw_flag],5
    je    .tex_mapping
    cmp   [draw_flag],8
    je    .bump_tex_mapping
    cmp   [draw_flag],7
    je    .two_tex
    cmp   [draw_flag],6
    je    .grd_tex
    cmp   [draw_flag],10
    je    .flat_draw_float
    cmp   [draw_flag],0
    je    .point_light
    cmp   [draw_flag],15
    je    .real_phong
    cmp   [draw_flag],16
    je    .r_ph_bi_tex
    cmp   [draw_flag],17
    je    .glass
    cmp   [draw_flag],21
    je    .fur
    cmp   [draw_flag],18
    jge    .glass_tex
;    cmp   [draw_flag],19
;    je    .glass_tex












     .grd_draw:                ;****Gouraud shading****
        fninit


        push   word .y_max
        push   .y_min
        lea     esi, .third_p_index
        lea     ebx, .zz1
        mov     ecx,3
      .again_grd_draw:
        mov     eax,[esi]
        add     eax,[points_normals_rotated_ptr]
        fld     dword[eax]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .x_temp_var    ; x temp variables
        fld     dword[eax+4]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .y_temp_var

        mov     eax,.y_temp_var
        shl     eax,TEX_SHIFT
        add     eax,.x_temp_var
        lea     eax,[4*eax+color_map]
        mov     eax,dword[eax]
        push    word[ecx*2+ebx-2]


        ror      eax,16               ; eax -0xxxrrggbb -> 0xggbbxxrr
        xor      ah,ah
        push     ax         ;r
        rol      eax,8                ; eax-0xggbb00rr -> 0xbb00rrgg
        xor      ah,ah
        push     ax         ;g
        shr      eax,24
        push     ax         ;b

        sub      esi,4
        dec      ecx
        jnz      .again_grd_draw

if 0
   ; -----------version with only one light supported------
    mov   [.counter],4      ; ++++ gouraud shading  ++++++++
  .calc_col_LVD:    ; calculate color Light Vector Depend
    mov   edx,[.counter]
    push  [zz1+edx]
; calc color of triangle light vector dependent
    mov   esi,light_vect
    mov   edi,[points_normals_rotated_ptr]
    add   edi,[first_p_index+2*edx]
    call  dot_product
    fst   [.dpr]            ; orginal+specular*st+emmisive*st^5
    push  ecx               ; o + min*st + max * st^5
    mov   ecx,5             ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]          ; dot product powered
    pop   ecx


    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

;    shufps    xmm3,xmm3,11000110b

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxuw    xmm3,[minimum0]
;    pminuw    xmm3,[maximum255]

    movd      edx,xmm3
  ;  ror       edx,16
    push      edx
    psrldq    xmm3,4
    movd      edx,xmm3
    push      dx

    sub   [.counter],2
    cmp   [.counter],0
    jge   .calc_col_LVD


end if

    mov     eax,[.xy1]
    mov     ebx,[.xy2]
    mov     ecx,[.xy3]

    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]
    call  gouraud_triangle_z
    jmp   .end_draw





  .point_light:
    push     word .y_max
    push     .y_min
    movups   xmm5,[point_light_coords]
    xor      eax,eax
    lea      esi,.first_p_index
  .next_vertex:
    movaps   xmm1,xmm5
    mov      ebx,[esi+2*eax]

    mov      edx,ebx
    add      ebx,[points_rotated_ptr]
    movups   xmm2,[ebx]
    andps    xmm2,[zero_hgst_dd]
    subps    xmm1,xmm2
    sub      esp,16
    movups   [esp],xmm1
    mov      edi,esp
    call     normalize_vector  ; uses xmm6,xmm7
    movups   xmm1,[edi]
    add      esp,16
    add      edx,[points_normals_rotated_ptr]
    movups   xmm3,[edx]
    andps    xmm3,[zero_hgst_dd]
    mulps    xmm3,xmm1
    haddps   xmm3,xmm3     ; sse3 required
    haddps   xmm3,xmm3     ; xmm3 - dot product
    xorps    xmm4,xmm4
    maxps    xmm3,xmm4
    shufps   xmm3,xmm3,11000000b
    movaps   xmm4,xmm3
    mov      ecx,5
  @@:
    mulps    xmm4,xmm4
    sub      ecx,1
    jnz      @b

;    imul     eax,[i38]     ; 38 - one light parameter size
    movq      xmm0,[p_light_max]    ;+eax
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    mulps     xmm4,xmm2     ; xmm4 reflection(emmisive?) component of light

    movq      xmm0,[p_light_o] ;+ eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm4,xmm2

    movq      xmm0,[p_light_min] ; + eax
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0

    mulps     xmm2,xmm3
    addps     xmm4,xmm2
    minps     xmm4,[mask_255f]

    cvtps2dq  xmm4,xmm4
    packssdw  xmm4,xmm4

    movd      edx,xmm4
    lea       edi,.zz1
    push      word[edi+eax]
    push      edx
    psrldq    xmm4,4
    movd      edx,xmm4
    push      dx

    add       eax,2
    cmp       eax,6
    jnz       .next_vertex

    mov     eax,[.xy3]
    mov     ebx,[.xy2]
    mov     ecx,[.xy1]

    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]
    call  gouraud_triangle_z


    jmp   .end_draw

if 0
  .r_phg_ray_shd:
        mov    esi,.first_p_index
        add    esi,[points_normals_rotated_ptr]
        movups xmm0,[esi]
        andps  xmm0,[zero_hgst_dd]
        mov    eax,.second_p_index
        add    eax,[points_normals_rotated_ptr]
        movups xmm1,[eax]
        andps  xmm1,[zero_hgst_dd]
        mov    ebx,.third_p_index
        add    ebx,[points_normals_rotated_ptr]
        movups xmm2,[ebx]
        andps  xmm2,[zero_hgst_dd]
        movups xmm3,[point_light_coords]
        andps  xmm3,[zero_hgst_dd]
        movups xmm4,.zz3f  ;[ecx]
        shufps xmm4,xmm4,11000110b
        andps  xmm4,[zero_hgst_dd]
; xmm5 - lo -> hi y_min, y_max, x_min, x_max as dword integers -
        pxor       xmm6,xmm6
        movq       xmm5,.y_max
        punpcklwd  xmm5,xmm6
        pshufd     xmm5,xmm5,10110001b
   ;     movzx      eax,[xres_var]
   ;     sub        eax,1
   ;     mov        dword .x_max,eax
   ;     movzx      eax,[yres_var]
   ;     sub        eax,1
   ;     mov        dword .y_max,eax
   ;     movaps     xmm5,.y_min
;        pxor       xmm6,xmm6
;        movq       xmm5,.y_max
;        punpcklwd  xmm5,xmm6
;        pshufd     xmm5,xmm5,10110001b
        emms
        movzx    eax,[triangles_count_var]
        movzx    ebx,[points_count_var]
        movd     mm0,[triangles_ptr]
        movd     mm1,[points_rotated_ptr]
        movd     mm2,eax
        movd     mm3,ebx

        mov      eax,[.xy1]
        mov      ebx,[.xy2]
        mov      ecx,[.xy3]
        mov      edx,[Zbuffer_ptr]
        mov      esi,[Zbuffer_ptr]
        mov      edi,[screen_ptr]
        call     RayShadowRealPhg_tri
        fninit
        jmp     .end_draw

end if

  .glass:
        mov    esi,.first_p_index
        add    esi,[points_normals_rotated_ptr]
        movups xmm0,[esi]
        andps  xmm0,[zero_hgst_dd]
        mov    eax,.second_p_index
        add    eax,[points_normals_rotated_ptr]
        movups xmm1,[eax]
        andps  xmm1,[zero_hgst_dd]
        mov    ebx,.third_p_index
        add    ebx,[points_normals_rotated_ptr]
        movups xmm2,[ebx]
        andps  xmm2,[zero_hgst_dd]
        movups xmm3,[lights_aligned]
        andps  xmm3,[zero_hgst_dd]
      ;  lea    ecx,.zz3f
        movups xmm4,.zz3f  ;[ecx]
        shufps xmm4,xmm4,11000110b
        andps  xmm4,[zero_hgst_dd]
   ;     shufps xmm4,xmm4,11000110b
; xmm5 - lo -> hi y_min, y_max, x_min, x_max as dword integers -
        pxor       xmm6,xmm6
        movq       xmm5,.y_max
        punpcklwd  xmm5,xmm6
        pshufd     xmm5,xmm5,10110001b
   ;     movzx      eax,[xres_var]
   ;     sub        eax,1
   ;     mov        dword .x_max,eax
   ;     movzx      eax,[yres_var]
   ;     sub        eax,1
   ;     mov        dword .y_max,eax
   ;     movaps     xmm5,.y_min
;        pxor       xmm6,xmm6
;        movq       xmm5,.y_max
;        punpcklwd  xmm5,xmm6
;        pshufd     xmm5,xmm5,10110001b

        mov      eax,[.xy1]
        mov      ebx,[.xy2]
        mov      ecx,[.xy3]
        mov      edx,[Zbuffer_ptr]
        mov      esi,[Zbuffer_ptr]
        mov      edi,[screen_ptr]
        call  glass_tri
        jmp   .end_draw




   .glass_tex:       ; glass like + texture + real Phong

        mov    esi,.first_p_index
        add    esi,[points_normals_rotated_ptr]
        movups xmm0,[esi]
        andps  xmm0,[zero_hgst_dd]
        mov    eax,.second_p_index
        add    eax,[points_normals_rotated_ptr]
        movups xmm1,[eax]
        andps  xmm1,[zero_hgst_dd]
        mov    ebx,.third_p_index
        add    ebx,[points_normals_rotated_ptr]
        movups xmm2,[ebx]
        andps  xmm2,[zero_hgst_dd]
        movups xmm3,[lights]
        andps  xmm3,[zero_hgst_dd]
        movups xmm4,.zz3f
        andps  xmm4,[zero_hgst_dd]
        shufps xmm4,xmm4,11000110b
; xmm5 - lo -> hi y_min, y_max, x_min, x_max as dword integers -
        pxor       xmm6,xmm6
        movq       xmm5,.y_max
        punpcklwd  xmm5,xmm6
        pshufd     xmm5,xmm5,10110001b
 if 1
        mov    eax, .third_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .second_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .first_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]
  end if
   ;     push   dword 1 shl 16 + 1
   ;     push   dword 511 shl 16 + 1
   ;     push   dword 256  shl 16 + 511
        movdqu xmm6,[esp]
        add    esp,12
     ;   pshufd xmm6,xmm6,11000110b




        movzx      edx,[xres_var]
        movd       xmm7,edx
        pshufd     xmm7,xmm7,00111111b
        pand       xmm6,[zero_hgst_dd]
        por        xmm6,xmm7

        mov      eax,[.xy1]
        mov      ebx,[.xy2]
        mov      ecx,[.xy3]
        mov      edx,texmap
        mov      esi,[Zbuffer_ptr]
        mov      edi,[screen_ptr]
;        cmp      [draw_flag],20
;        jne      @f
;        movd     xmm7,[slices_counter_ptr]
;        mov      esi,[slices_ptrs_buff_ptr]
;        call     glass_tex_tri_sl_var
;        jmp      .end_draw
      @@:
        cmp      [draw_flag],19
        je       @f
        call     glass_tex_tri
        jmp      .end_draw
     @@:
        call     glass_tex_tri_sl
        jmp      .end_draw


       .real_phong:                ;****Phong shading****



        mov    esi,.first_p_index
        add    esi,[points_normals_rotated_ptr]
        movups xmm0,[esi]
        andps  xmm0,[zero_hgst_dd]
        mov    eax,.second_p_index
        add    eax,[points_normals_rotated_ptr]
        movups xmm1,[eax]
        andps  xmm1,[zero_hgst_dd]
        mov    ebx,.third_p_index
        add    ebx,[points_normals_rotated_ptr]
        movups xmm2,[ebx]
        andps  xmm2,[zero_hgst_dd]
        movups xmm3,[lights]
        andps  xmm3,[zero_hgst_dd]
        lea    ecx,.zz3f
        movups xmm4,[ecx]
        andps  xmm4,[zero_hgst_dd]
        shufps xmm4,xmm4,11000110b
; xmm5 - lo -> hi y_min, y_max, x_min, x_max as dword integers -
        pxor       xmm6,xmm6
        movq       xmm5,.y_max
        punpcklwd  xmm5,xmm6
        pshufd     xmm5,xmm5,10110001b
        mov      eax,0x00aa3333
        movd     mm0,eax
        movd     mm1,[slices_ptrs_buff_ptr]
        mov      eax,[.xy1]
        mov      ebx,[.xy2]
        mov      ecx,[.xy3]

        mov   esi,[Zbuffer_ptr]
        mov   edi,[screen_ptr]
        call  real_phong_tri_col_stencil
        jmp   .end_draw

    .r_ph_bi_tex:                ;****Phong shading + bi linear tex****



        mov    esi,.first_p_index
        add    esi,[points_normals_rotated_ptr]
        movups xmm0,[esi]
        andps  xmm0,[zero_hgst_dd]
        mov    eax,.second_p_index
        add    eax,[points_normals_rotated_ptr]
        movups xmm1,[eax]
        andps  xmm1,[zero_hgst_dd]
        mov    ebx,.third_p_index
        add    ebx,[points_normals_rotated_ptr]
        movups xmm2,[ebx]
        andps  xmm2,[zero_hgst_dd]
        movups xmm3,[lights]
        andps  xmm3,[zero_hgst_dd]
        movups xmm4,.zz3f
        andps  xmm4,[zero_hgst_dd]
        shufps xmm4,xmm4,11000110b
; xmm5 - lo -> hi y_min, y_max, x_min, x_max as dword integers -
        pxor       xmm6,xmm6
        movq       xmm5,.y_max
        punpcklwd  xmm5,xmm6
        pshufd     xmm5,xmm5,10110001b
 if 1
        mov    eax, .third_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .second_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .first_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]
  end if
   ;     push   dword 1 shl 16 + 1
   ;     push   dword 511 shl 16 + 1
   ;     push   dword 256  shl 16 + 511
        movdqu xmm6,[esp]
        add    esp,12
     ;   pshufd xmm6,xmm6,11000110b




        movzx      edx,[xres_var]
        movd       xmm7,edx
        pshufd     xmm7,xmm7,00111111b
        pand       xmm6,[zero_hgst_dd]
        por        xmm6,xmm7

        mov      eax,[.xy1]
        mov      ebx,[.xy2]
        mov      ecx,[.xy3]
        mov      edx,texmap
        mov      esi,[Zbuffer_ptr]
        mov      edi,[screen_ptr]
        call     r_phg_bi_fil
        jmp     .end_draw




if 0
  .ggrd_line:;****Gouraud line****

        fninit
        push   word .y_max
        push   .y_min

        lea     esi,.third_p_index
        mov     ecx,3
      .again_grd_line_param:
        mov     eax,[esi]
        add     eax,[points_normals_rotated_ptr]
        fld     dword[eax]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .x_temp_var    ; x temp variables
        fld     dword[eax+4]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .y_temp_var

        mov     eax,.y_temp_var
        shl     eax,TEX_SHIFT
        add     eax,.x_temp_var
        lea     eax,[4*eax+color_map]
        mov     eax,dword[eax]
        mov     [ecx*4+col1-4],eax

        sub      esi,4
        dec      ecx                    ; decode all 3 edges
        jnz      .again_grd_line_param


        mov     edi,[screen_ptr]
        mov     esi,[Zbuffer_ptr]

        mov     eax,[col1]
        movzx   bx,al
        push    bx                ; b
        movzx   bx,ah
        push    bx
        rol     eax,16
        xor     ah,ah
        push    ax
        push    word .zz1

        mov     eax,[.xy1]
        ror     eax,16
        push    eax

        mov     eax,[col2]
        movzx   bx,al
        push    bx                ; b
        movzx   bx,ah
        push    bx
        rol     eax,16
        xor     ah,ah
        push    ax
        push    word .zz2

        mov      eax,[.xy2]
        ror      eax,16
        push     eax

        call    smooth_line     ; draw only one edge

    jmp   .end_draw
end if




    .grd_tex:
        push   word .y_max
        push   .y_min

        fninit

        mov    eax, .third_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .second_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .first_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        lea     esi, .third_p_index
        mov     ecx,3

      .again_grd_tex_draw:

        mov     eax,[esi]
        add     eax,[points_normals_rotated_ptr]
        fld     dword[eax]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .x_temp_var    ; x temp variables
        fld     dword[eax+4]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .y_temp_var

        mov     eax,.y_temp_var
        shl     eax,TEX_SHIFT
        add     eax,.x_temp_var
        lea     eax,[4*eax+color_map]
        mov     eax,dword[eax]
        lea     ebx,.zz1
        push    word[ecx*2+ebx-2]


        ror      eax,16               ; eax -0xxxrrggbb -> 0xggbbxxrr
        xor      ah,ah
        push     ax         ;r
        rol      eax,8                ; eax-0xggbb00rr -> 0xbb00rrgg
        xor      ah,ah
        push     ax         ;g
        shr      eax,24
        push     ax         ;b

        sub      esi,4
        dec      ecx
        jnz      .again_grd_tex_draw


        mov    eax,[.xy1]
        mov    ebx,[.xy2]
        mov    ecx,[.xy3]

        mov     edi,[screen_ptr]   ; screen buffer
        mov     esi,[Zbuffer_ptr]
        mov     edx,texmap

        call    tex_plus_grd_triangle



        jmp    .end_draw



     .flat_draw:                     ;**************************                                     ; FLAT DRAWING
        fninit

        mov     eax,.first_p_index
        add     eax,[points_normals_rotated_ptr]
        fld     dword[eax]
        mov     ebx,.second_p_index
        add     ebx,[points_normals_rotated_ptr]
        fadd    dword[ebx]
        mov     ecx,.third_p_index
        add     ecx,[points_normals_rotated_ptr]
        fadd    dword[ecx]

        fidiv   [i3]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .x_temp_var ;[esp-4]    ; x temp variables
        fld     dword[eax+4]    ; y cooficient of normal vector
        fadd    dword[ebx+4]
        fadd    dword[ecx+4]
        fidiv   [i3]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .y_temp_var;[esp-8]   ;  y
        mov     edx,.x_temp_var  ; dword[esp-8]
        shl     edx,TEX_SHIFT
        add     edx,.y_temp_var ;dword[esp-4]
        lea     eax,[4*edx+color_map]
        mov     edx,dword[eax]
        or      edx,0xff000000   ; edx - color


        mov     eax,[.xy1]
        mov     ebx,[.xy2]
        mov     ecx,[.xy3]

        mov     edi,[screen_ptr]
        mov     esi,[Zbuffer_ptr]
        push    .y_min
        push    word .y_max
        push     word .zz3
        push     word .zz2
        push     word .zz1

        call    flat_triangle_z

    jmp   .end_draw






    .env_mapping:
        push    word .y_max
        push    .y_min
        push     word .zz3
        push     word .zz2
        push     word .zz1
        fninit
        xor     esi,esi
        sub     esp,12
        mov     edi,esp
        mov     .counter,3
        lea     ebx,.first_p_index
      @@:
        mov     edx,[esi+ebx]
        add     edx,[points_normals_rotated_ptr]    ;point_normals_rotated
        ; texture x=(rotated point normal -> x * 255)+255
        fld     dword[edx]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   word[edi]
        ; texture y=(rotated point normal -> y * 255)+255
        fld     dword[edx+4]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   word[edi+2]

        add     edi,4
        add     esi,4
        sub     .counter,1
        jnz     @b

        mov    eax,[.xy1]
        mov    ebx,[.xy2]
        mov    ecx,[.xy3]

        mov     edi,[screen_ptr]   ; screen buffer
        mov     esi,envmap
        mov     edx,[Zbuffer_ptr]
        call    tex_triangle_z

        jmp     .end_draw


 .flat_draw_float:
    movzx  ebx,[yres_var]
    movzx  eax,[xres_var]
    push   ebx
    push   eax
    push   dword .zz3f
    push   .zz2f
    push   .zz1f


; calc color of triangle light vector dependent

        fninit

        mov     eax, .first_p_index
        add     eax,[points_normals_rotated_ptr]
        fld     dword[eax]
        mov     ebx, .second_p_index
        add     ebx,[points_normals_rotated_ptr]
        fadd    dword[ebx]
        mov     ecx, .third_p_index
        add     ecx,[points_normals_rotated_ptr]
        fadd    dword[ecx]

        fidiv   [i3]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .x_temp_var ;[esp-4]    ; x temp variables
        fld     dword[eax+4]    ; y cooficient of normal vector
        fadd    dword[ebx+4]
        fadd    dword[ecx+4]
        fidiv   [i3]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   .y_temp_var;[esp-8]   ;  y
        mov     edx,.x_temp_var  ; dword[esp-8]
        shl     edx,TEX_SHIFT
        add     edx,.y_temp_var ;dword[esp-4]
        lea     eax,[4*edx+color_map]
        mov     edx,dword[eax]
        or      edx,0xff000000   ; edx - color

        mov     eax,[.xy1]
        mov     ebx,[.xy2]
        mov     ecx,[.xy3]


if 0
    mov   esi,light_vect
    mov   edi,[points_normals_rotated_ptr]
    add   edi,[first_p_index]
    call  dot_product
    fst   [.dpr]            ; orginal+specular*st+emmisive*st^5
    push  ecx               ; o + min*st + max * st^5
    mov   ecx,5             ; shiness
  @@:
    fmul  st,st0
    loop  @b
    fstp  [.dpr_p]          ; dot product powered
    pop   ecx

    movq      xmm0,[light_c_max]
    pxor      xmm1,xmm1
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm3,[.dpr_p]
    shufps    xmm3,xmm3,0
    mulps     xmm3,xmm2

    movq      xmm0,[light_c_o]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    addps     xmm3,xmm2

    movq      xmm0,[light_c_min]
    punpcklwd xmm0,xmm1
    cvtdq2ps  xmm2,xmm0
    movss     xmm4,[.dpr]
    shufps    xmm4,xmm4,0
    mulps     xmm2,xmm4
    addps     xmm3,xmm2

    cvtps2dq  xmm3,xmm3
    packssdw  xmm3,xmm3
;    pmaxub    xmm3,[minimum0]
;    pminub    xmm3,[maximum255]
    packuswb  xmm3,xmm3
    movd      edx,xmm3
end if




    mov   esi,[Zbuffer_ptr]
    mov   edi,[screen_ptr]

    call  flat_triangle_z_float
    jmp     .end_draw
;end if

  .tex_mapping:
        push    word .y_max
        push    .y_min
        push     word .zz3
        push     word .zz2
        push     word .zz1
   ;  cmp    [hrt_flag],3          ; check tetrahedron object cause
   ;  je     @f
        mov    eax,.third_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax,.second_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax,.first_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

    .no_tetra:
        mov    eax,[.xy1]
        mov    ebx,[.xy2]
        mov    ecx,[.xy3]

        mov     edi,[screen_ptr]   ; screen buffer
        mov     esi,texmap
        mov     edx,[Zbuffer_ptr]
        call    tex_triangle_z

        jmp     .end_draw


    .bump_mapping:
        push    word .y_max
        push    .y_min
        push    [Zbuffer_ptr]
        push     word .zz3
        push     word .zz2
        push     word .zz1

        fninit
        xor     esi,esi
        sub     esp,12
        mov     edi,esp
        mov     .counter,3
        lea     ebx,.first_p_index
      @@:
        mov     edx,[esi+ebx]
        add     edx,[points_normals_rotated_ptr]    ;point_normals_rotated
        ; texture x=(rotated point normal -> x * 255)+255
        fld     dword[edx]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   word[edi]
        ; texture y=(rotated point normal -> y * 255)+255
        fld     dword[edx+4]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   word[edi+2]

        add     edi,4
        add     esi,4
        dec     .counter
        jnz     @b

        mov    eax, .third_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .second_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .first_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax,[.xy1]
        mov    ebx,[.xy2]
        mov    ecx,[.xy3]

        mov     edi,[screen_ptr]
        mov     esi,envmap
        mov     edx,bump_map            ;BUMP_MAPPING

        call    bump_triangle_z
        jmp    .end_draw

    .two_tex:               ; double texture mapping
        push    word .y_max
        push    .y_min
        push    [Zbuffer_ptr]
        push     word .zz3
        push     word .zz2
        push     word .zz1

        fninit
        xor     esi,esi
        sub     esp,12
        mov     edi,esp
        mov     .counter,3
        lea     ebx,.first_p_index
      @@:
        mov     edx,[esi+ebx]
        add     edx,[points_normals_rotated_ptr]    ;point_normals_rotated
        ; texture x=(rotated point normal -> x * 255)+255
        fld     dword[edx]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   word[edi]
        ; texture y=(rotated point normal -> y * 255)+255
        fld     dword[edx+4]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   word[edi+2]

        add     edi,4
        add     esi,4
        dec     .counter
        jnz     @b

   ;  cmp    [hrt_flag],3          ; check tetrahedron object cause
   ;  je     @f

        mov    eax, .third_p_index      ; tex coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .second_p_index      ; tex coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .first_p_index      ; tex coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]



        mov    eax,[.xy1]
        mov    ebx,[.xy2]
        mov    ecx,[.xy3]

        mov     edi,[screen_ptr]
        mov     esi,envmap
        mov     edx,texmap

        call    two_tex_triangle_z
        jmp    .end_draw


    .bump_tex_mapping:
        push   word .y_max
        push   .y_min
        mov    eax,.third_p_index      ; tex coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax,.second_p_index      ; tex coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax,.first_p_index      ; tex coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        push    texmap

        push    [Zbuffer_ptr]
        push    word  .zz3
        push    word  .zz2
        push    word  .zz1

        fninit
        xor     esi,esi
        sub     esp,12
        mov     edi,esp
        mov     .counter,3
      @@:
        lea     edx,.first_p_index
        mov     edx,[edx+esi]
        add     edx,[points_normals_rotated_ptr]    ;point_normals_rotated
        ; texture x=(rotated point normal -> x * 255)+255
        fld     dword[edx]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   word[edi]
        ; texture y=(rotated point normal -> y * 255)+255
        fld     dword[edx+4]
        fimul   [correct_tex]
        fiadd   [correct_tex]
        fistp   word[edi+2]

        add     edi,4
        add     esi,4
        dec     .counter
        jnz     @b

    ; cmp    [hrt_flag],3          ; check tetrahedron object cause
    ; je     @f
        mov    eax, .third_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .second_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]

        mov    eax, .first_p_index      ; bump map coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        push   dword[eax]




        mov    eax,[.xy1]
        mov    ebx,[.xy2]
        mov    ecx,[.xy3]

        mov     edi,[screen_ptr]
        mov     esi,envmap
        mov     edx,bump_map            ;BUMP_MAPPING

        call    bump_tex_triangle_z
        jmp   .end_draw
     .fur:

        mov    eax,.third_p_index      ; tex coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        movd   xmm0,[eax]


        mov    eax,.second_p_index      ; tex coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        movd   xmm1,[eax]

        mov    eax,.first_p_index      ; tex coords
        cdq
        idiv   [i3]
        add    eax,[tex_points_ptr]
        movd   xmm2,[eax]
    ;    mov    ebx,[temp_fur]
    ;    and    ebx,1111b
    ;    mov    [temp_fur],ebx
    ;    movd   xmm3,ebx
    ;    shr    ebx,1
    ;    movd   xmm4,ebx
    ;    shr    ebx,1
    ;    movd   xmm5,ebx
    ;    shr    ebx,1
    ;    movd   xmm6,ebx
    ;    pshufd xmm3,xmm3,0
    ;    pshufd xmm4,xmm4,0
    ;    pshufd xmm5,xmm5,0
    ;    pshufd xmm6,xmm6,0
        punpcklwd  xmm0,[the_zero]
        punpcklwd  xmm1,[the_zero]
        punpcklwd  xmm2,[the_zero]
    ;    psrld      xmm0,1
    ;    psrld      xmm1,1
    ;    psrld      xmm2,1

    ;    paddd      xmm0,xmm5
    ;    paddd      xmm1,xmm4
    ;    paddd      xmm2,xmm3
        cvtdq2ps   xmm0,xmm0
        cvtdq2ps   xmm1,xmm1
        cvtdq2ps   xmm2,xmm2
        shufps     xmm0,xmm0,11100001b
        shufps     xmm1,xmm1,11100001b
        shufps     xmm2,xmm2,11100001b
        sub    esp,150
        mov    edx,esp
        add    edx,16
        and    edx,-16
        movlps [edx],xmm2
        movlps [edx+8],xmm1
        movlps [edx+16],xmm0
        movlps [edx+24],xmm2
        movlps [edx+32],xmm1
        movlps [edx+40],xmm0
        movlps [edx+48],xmm2
        movlps [edx+56],xmm1
        movlps [edx+64],xmm0
        movlps [edx+72],xmm2
        movlps [edx+80],xmm1
        movlps [edx+88],xmm0


        mov    esi,.first_p_index
        add    esi,[points_normals_rotated_ptr]
        movups xmm0,[esi]
        andps  xmm0,[zero_hgst_dd]
        mov    eax,.second_p_index
        add    eax,[points_normals_rotated_ptr]
        movups xmm1,[eax]
        andps  xmm1,[zero_hgst_dd]
        mov    ebx,.third_p_index
        add    ebx,[points_normals_rotated_ptr]
        movups xmm2,[ebx]
        andps  xmm2,[zero_hgst_dd]
        lea    ecx,.zz3f
        movups xmm4,[ecx]
        andps  xmm4,[zero_hgst_dd]
        shufps xmm4,xmm4,11000110b
; xmm5 - lo -> hi y_min, y_max, x_min, x_max as dword integers -
;        movd      xmm5,[xres_vard]
;        punpcklwd xmm5,[the_zero]
;        pshufd    xmm5,xmm5,00110111b

; xmm5 - lo -> hi y_min, y_max, x_min, x_max as dword integers -
        movq       xmm5,.y_max
        punpcklwd  xmm5,[the_zero]
        pshufd     xmm5,xmm5,10110001b




        movd      xmm6,[furs_ptr]



        mov      eax,[.xy1]
        mov      ebx,[.xy2]
        mov      ecx,[.xy3]

        mov   esi,[Zbuffer_ptr]
        mov   edi,[screen_ptr]
        call  fur_phong_tri_z



        add   esp,150
        jmp   .end_draw





   .end_draw:

    popad
    pop   esi
    add   esi,12
    pop    ecx
    inc    ecx
    cmp    ecx,[triangles_count_var]
    jnz    .draw_triangle
    jmp    .the_end

 .draw_edges:


    cmp   [draw_flag],9
    je    .grd_line
    cmp   [draw_flag],11
    je    .env_line
    cmp   [draw_flag],12
    je    .tex_line
    cmp   [draw_flag],13
    je    .flat_line




  .flat_line:
    mov   ecx,[edges_count]
    mov   esi,[edges_ptr]
  .dr_edge:
    push  ecx
    push  esi
    mov   ebx,dword[esi]
    mov   eax,dword[esi+4]
    imul  ebx,[i12]
    imul  eax,[i12]
    mov   ecx,eax
    mov   edx,ebx
    add   ebx,[points_rotated_ptr]
    add   eax,[points_rotated_ptr]
    movups   xmm0,[ebx]
    movups   xmm1,[eax]
    shufps   xmm0,xmm0,11100001b
    shufps   xmm1,xmm1,11100001b
    movlhps  xmm0,xmm1
    cvtps2dq xmm0,xmm0
    packssdw xmm0,xmm0
    movdqa   xmm7,xmm0

    ; check if line is in visable area
    pxor     xmm3,xmm3
    movd     xmm4,[xres_vard]
    pshuflw  xmm4,xmm4,11110001b
    pshufd   xmm4,xmm4,11110000b
    pcmpgtw  xmm4,xmm0
    pcmpgtw  xmm3,xmm0
    pxor     xmm3,xmm4
    pmovmskb eax,xmm3
    and      eax,0x000000ff
    cmp      eax,0xff
    jne     .end_dr_ed

if 0

        add    ecx,[points_normals_rotated_ptr]
        add    edx,[points_normals_rotated_ptr]
        movlps xmm6,[ecx]
        movhps xmm6,[edx]

        mulps    xmm6,[correct_tex_x4f]
        addps    xmm6,[correct_tex_x4f]
        cvtps2dq xmm6,xmm6
        movd     eax,xmm6
        psrldq   xmm6,4
        movd     ebx,xmm6
        shl      eax,TEX_SHIFT
        add      eax,ebx
        psrldq   xmm6,4
        lea      eax,[4*eax+color_map]
        movd     xmm0,[eax]  ; col1

        movd     eax,xmm6
        psrldq   xmm6,4
        movd     ebx,xmm6
        shl      ebx,TEX_SHIFT
        add      ebx,eax
        lea      ebx,[4*ebx+color_map]
        movd     xmm1,[ebx]  ;col2

        punpcklbw  xmm0,[the_zero]
        punpcklbw  xmm1,[the_zero]
        punpcklwd  xmm0,[the_zero]
        punpcklwd  xmm1,[the_zero]
        cvtdq2ps   xmm0,xmm0
        cvtdq2ps   xmm1,xmm1
        andps      xmm0,[zero_hgst_dd]
        andps      xmm1,[zero_hgst_dd]
        mov        eax,1.0
        movd       xmm6,eax
        shufps     xmm6,xmm6,00111111b
    ;    orps       xmm0,xmm6
        orps       xmm1,xmm6
end if
     mov      ebx,0x0000ff00
     movd     mm3,ebx    ; color
     movd     eax,xmm7
     movzx    ebx,ax
     shr      eax,16
     psrldq   xmm7,4
     movd     ecx,xmm7
     movzx    edx,cx
     shr      ecx,16
     pxor     xmm6,xmm6
     movd     mm1,[screen_ptr]
     movd     mm0,[Zbuffer_ptr]
     movzx    esi,[xres_var]
     movd     mm2,esi
     movd     xmm7,[xres_vard]
     punpcklwd xmm7,xmm6
     pshufd   xmm7,xmm7,0
     call     linea          ; line grd trans
   .end_dr_ed:
     pop  esi
     pop  ecx
     add  esi,8
     sub  ecx,1
     jnz  .dr_edge

     jmp  .the_end


     .env_line:

        mov   ecx,[edges_count]
        mov   esi,[edges_ptr]
    .edge_env_loop:
        push  ecx
        push  esi
        push  ebp
        mov   ebx,dword[esi]
        mov   eax,dword[esi+4]
        imul  ebx,[i12]
        imul  eax,[i12]
        add   ebx,[points_normals_rotated_ptr]
        add   eax,[points_normals_rotated_ptr]
        sub   esp,4
        movlps  xmm0,[ebx]
        movhps  xmm0,[eax]
        movzx   ecx,[correct_tex]
        cvtsi2ss xmm3,ecx
        shufps  xmm3,xmm3,0
        mulps   xmm0,xmm3
        addps   xmm0,xmm3
        cvtps2dq xmm0,xmm0
        packssdw xmm0,xmm0
        movd     [esp],xmm0  ; tex env coords
        mov      eax,dword[esi]
        mov      ebx,dword[esi+4]
        imul     eax,[i12]
        imul     ebx,[i12]
        add      eax,[points_rotated_ptr]
        add      ebx,[points_rotated_ptr]
        movups   xmm1,[eax]
        movups   xmm2,[ebx]
        shufps   xmm1,xmm1,11001001b
        shufps   xmm2,xmm2,11001001b
        cvtps2dq xmm1,xmm1
        cvtps2dq xmm2,xmm2
        packssdw xmm1,xmm1
        packssdw xmm2,xmm2
        movd     eax,xmm1
        push     eax
        psrldq   xmm1,4
        movd     eax,xmm1
        push     ax

        sub      esp,4
        psrldq   xmm0,8
        movd     [esp],xmm0
        movd     ebx,xmm2
        push     ebx
        psrldq   xmm2,4
        movd     ebx,xmm2
        push     bx

        mov     edi,[screen_ptr]
        mov     esi,[Zbuffer_ptr]
        mov     edx,envmap
        call    tex_line     ; draw only one edge

        pop     ebp
        pop     esi
        pop     ecx
        add     esi,8
        sub     ecx,1
        jnz     .edge_env_loop

        jmp     .the_end


    .tex_line:
        mov    ecx,[edges_count]
        mov    esi,[edges_ptr]
     .tex_loop:
        push   ecx
        push   esi
        push   ebp
        mov    eax,dword[esi]
        mov    ebx,dword[esi+4]
        shl    eax,2
        shl    ebx,2
        add    eax,[tex_points_ptr]
        add    ebx,[tex_points_ptr]
        push   dword[eax]
        mov    eax,dword[esi]
        imul   eax,[i12]
        add    eax,[points_rotated_ptr]
        movups xmm0,[eax]
        cvtps2dq xmm0,xmm0
        packssdw xmm0,xmm0
        movd   eax,xmm0
        pshufd xmm0,xmm0,00000001b
        movd   ecx,xmm0
        push   cx
        push   eax
        push   dword[ebx]
        mov    ebx,dword[esi+4]
        imul   ebx,[i12]
        add    ebx,[points_rotated_ptr]
        movups xmm0,[ebx]
        cvtps2dq xmm0,xmm0
        packssdw xmm0,xmm0
        movd   ebx,xmm0
        pshufd xmm0,xmm0,00000001b
        movd   edx,xmm0
        push   dx
        push   ebx
        mov     edi,[screen_ptr]
        mov     esi,[Zbuffer_ptr]
        mov     edx,texmap
     @@:
        call    tex_line     ; draw only one edge
        pop     ebp
        pop     esi
        pop     ecx
        add     esi,8
        sub     ecx,1
        jnz     .tex_loop
        jmp    .the_end

 .grd_line:                ;****Gouraud line****

    mov   ecx,[edges_count]
    mov   esi,[edges_ptr]
  .dr_grd:
    push  ecx
    push  esi
    mov   ebx,dword[esi]
    mov   eax,dword[esi+4]
    imul  ebx,[i12]
    imul  eax,[i12]
    mov   ecx,eax
    mov   edx,ebx
    add   ebx,[points_rotated_ptr]
    add   eax,[points_rotated_ptr]
    movups   xmm0,[ebx]
    movups   xmm1,[eax]
    shufps   xmm0,xmm0,11100001b
    shufps   xmm1,xmm1,11100001b
    movlhps  xmm0,xmm1
    cvtps2dq xmm0,xmm0
    packssdw xmm0,xmm0
    movdqa   xmm7,xmm0

    ; check if line is in visable area
    pxor     xmm3,xmm3
    movd     xmm4,[xres_vard]
    pshuflw  xmm4,xmm4,11110001b
    pshufd   xmm4,xmm4,11110000b
    pcmpgtw  xmm4,xmm0
    pcmpgtw  xmm3,xmm0
    pxor     xmm3,xmm4
    pmovmskb eax,xmm3
    and      eax,0x000000ff
    cmp      eax,0xff
    jne     .end_dr_grd

        add    ecx,[points_normals_rotated_ptr]
        add    edx,[points_normals_rotated_ptr]
        movlps xmm6,[ecx]
        movhps xmm6,[edx]

        mulps    xmm6,[correct_tex_x4f]
        addps    xmm6,[correct_tex_x4f]
        cvtps2dq xmm6,xmm6
        movd     eax,xmm6
        psrldq   xmm6,4
        movd     ebx,xmm6
        shl      eax,TEX_SHIFT
        add      eax,ebx
        psrldq   xmm6,4
        lea      eax,[4*eax+color_map]
        movd     xmm0,[eax]  ; col1

        movd     eax,xmm6
        psrldq   xmm6,4
        movd     ebx,xmm6
        shl      ebx,TEX_SHIFT
        add      ebx,eax
        lea      ebx,[4*ebx+color_map]
        movd     xmm1,[ebx]  ;col2

        punpcklbw  xmm0,[the_zero]
        punpcklbw  xmm1,[the_zero]
        punpcklwd  xmm0,[the_zero]
        punpcklwd  xmm1,[the_zero]
        cvtdq2ps   xmm0,xmm0
        cvtdq2ps   xmm1,xmm1
        andps      xmm0,[zero_hgst_dd]
        andps      xmm1,[zero_hgst_dd]
        mov        eax,1.0
        movd       xmm6,eax
        shufps     xmm6,xmm6,00111111b
        orps       xmm0,xmm6
        orps       xmm1,xmm6

     movd     eax,xmm7
     movzx    ebx,ax
     shr      eax,16
     psrldq   xmm7,4
     movd     ecx,xmm7
     movzx    edx,cx
     shr      ecx,16
     movd     mm1,[screen_ptr]
     movd     mm0,[Zbuffer_ptr]
     movzx    esi,[xres_var]
     movd     mm2,esi
     call     line_grd    ; linea
   .end_dr_grd:
     pop  esi
     pop  ecx
     add  esi,8
     sub  ecx,1
     jnz  .dr_grd

        jmp   .the_end

    .draw_vertices:
        mov      esi,[points_rotated_ptr]
        mov      ecx,[points_count_var]
        movzx    edx,[xres_var]

        pxor      xmm3,xmm3
        movd      xmm4,[xres_vard]
        punpcklwd xmm4,xmm3
;    pshuflw  xmm4,xmm4,11110001b
;    pshufd   xmm4,xmm4,11110000b
;    pcmpgtw  xmm4,xmm0
      .again_vert:
        movups    xmm0,[esi]
        cvtps2dq  xmm0,xmm0
        pxor      xmm3,xmm3
        movd      xmm4,[xres_vard]
        punpcklwd xmm4,xmm3


        ;    pxor     xmm3,xmm3
        ;    movd     xmm4,[xres_vard]
        ;    pshuflw  xmm4,xmm4,11110001b
        ;    pshufd   xmm4,xmm4,11110000b
        pcmpgtd  xmm4,xmm0
        pcmpgtd  xmm3,xmm0
        pxor     xmm3,xmm4
        pmovmskb eax,xmm3
        and      eax,0x000000ff
        cmp      eax,0xff
        jne      @f



        movd     eax,xmm0
        psrldq   xmm0,4
        movd     ebx,xmm0
        imul     ebx,edx
        add      ebx,eax
        shl      ebx,2
        add      ebx,[screen_ptr]
        mov      [ebx],dword 0x00ffffff
      @@:                         ;  skip vertex
        add      esi,12
        sub      ecx,1
        jnz      .again_vert


  .the_end:

  add esp,256
  pop ebp
ret