

CATMULL_SHIFT  equ 7
ROUND equ 8
;TEX_SIZE=0x3fff

; procedure drawing textured triangle with Gouraud shading
; Z-buffer alghoritm included, Z coord interpolation ----
; I set the color by this way -- (col1 * col2)/256 ------
;------------------in - eax - x1 shl 16 + y1 ------------
;---------------------- ebx - x2 shl 16 + y2 ------------
;---------------------- ecx - x3 shl 16 + y3 ------------
;---------------------- esi - pointer to Z-buffer--------
;---------------------- edx - pointer to texture---------
;---------------------- Z-buffer filled with dd variables
;---------------------- shifted CATMULL_SHIFT------------
;---------------------- edi - pointer to screen buffer---
;---------------------- stack : colors-------------------



tex_plus_grd_triangle:
; parameters :
   .y_max   equ [ebp+42]
   .y_min   equ [ebp+40]
   .tex_y3  equ [ebp+38]   ; 40 bytes through stack
   .tex_x3  equ [ebp+36]
   .tex_y2  equ [ebp+34]
   .tex_x2  equ [ebp+32]
   .tex_y1  equ [ebp+30]
   .tex_x1  equ [ebp+28]

   .z3	    equ [ebp+26]
   .col3b   equ [ebp+24]
   .col3g   equ [ebp+22]
   .col3r   equ [ebp+20]

   .z2	    equ [ebp+18]
   .col2b   equ [ebp+16]
   .col2g   equ [ebp+14]
   .col2r   equ [ebp+12]

   .z1	    equ [ebp+10]
   .col1b   equ [ebp+8]
   .col1g   equ [ebp+6]
   .col1r   equ [ebp+4]

; local variables:

   .tex_ptr   equ dword[ebp-4]
   .z_ptr     equ dword[ebp-8]
   .scr_buff  equ dword[ebp-12]

   .x1	      equ  word[ebp-14]
   .y1	      equ  word[ebp-16]
   .x2	      equ  word[ebp-18]
   .y2	      equ  word[ebp-20]
   .x3	      equ  word[ebp-22]
   .y3	      equ      [ebp-24]
   .alg_ptr   equ      [ebp-28]

   .dx12      equ  dword[edx-(32-24)]
   .tex_dx12  equ  dword[edx-(32-20)]
   .tex_dy12  equ	[edx-(32-16)]
   .dz12      equ  dword[edx-(32-12)]
   .dc12r     equ	[edx-(32-8 )]
   .dc12g     equ  dword[edx-(32-4 )]
   .dc12b     equ	[edx-32]

   .dx23      equ  dword[edx-(64-24)]
   .tex_dx23  equ  dword[edx-(64-20)]
   .tex_dy23  equ	[edx-(64-16)]
   .dz23      equ  dword[edx-(64-12)]
   .dc23r     equ	[edx-(64-8 )]
   .dc23g     equ  dword[edx-(64-4 )]
   .dc23b     equ	[edx-64]

   .dx13      equ  dword[edx-(96-24)]
   .tex_dx13  equ  dword[edx-(96-20)]
   .tex_dy13  equ	[edx-(96-16)]
   .dz13      equ  dword[edx-(96-12)]
   .dc13r     equ	[edx-(96-8 )]
   .dc13g     equ  dword[edx-(96-4 )]
   .dc13b     equ	[edx-96]

   .scan_x1   equ  dword[edx-(128-20)]
   .scan_y1   equ	[edx-(128-16)]
   .zz1       equ  dword[edx-(128-12)]
   .cur1r     equ	[edx-(128-8 )]
   .cur1g     equ  dword[edx-(128-4 )]
   .cur1b     equ	[edx-128]

   .scan_x2   equ  dword[edx-(160-20)]
   .scan_y2   equ	[edx-(160-16)]
   .zz2       equ	[edx-(160-12)]
   .cur2r     equ	[edx-(160-8 )]
   .cur2g     equ  dword[edx-(160-4 )]
   .cur2b     equ	[edx-160]

       emms
       mov    ebp,esp
       push    edx esi edi
;

   .sort3:
       cmp     ax,bx
       jle     .sort1
       xchg    eax,ebx

       movq    mm0, .col1r	 ; exchange r, g, b, z
       movq    mm1, .col2r
       movd    mm3,dword .tex_x1
       movd    mm4,dword .tex_x2
       movq    .col1r ,mm1
       movq    .col2r ,mm0
       movd    dword .tex_x1,mm4
       movd    .tex_x2,mm3

 .sort1:
       cmp	bx,cx
       jle	.sort2
       xchg    ebx,ecx

       movq    mm0, .col2r	 ; exchange r, g, b, z
       movq    mm1, .col3r
       movd    mm2,dword .tex_x2
       movd    mm3,dword .tex_x3
       movq    .col3r ,mm0
       movq    .col2r ,mm1
       movd    .tex_x3,mm2
       movd    .tex_x2,mm3

       jmp .sort3

 .sort2:

       push	eax ebx ecx	    ; store in variables

	movups	xmm0,.y3		; check if at last only fragment
	pand	xmm0,[draw_thread_mask] ; of triangle is in visable area
	movd	xmm1,.y_min
	packssdw xmm0,xmm0
	pshuflw xmm2,xmm1,01010101b
	pshuflw xmm1,xmm1,0
	movdqa	xmm3,xmm0
	pcmpgtw xmm3,xmm2
	pcmpgtw xmm0,xmm1
	pxor	xmm0,xmm3
	pmovmskb eax,xmm0
	and	al,00111111b
	or	al,al
	jz	.end ; .loop2_end


       sub   esp,24
       and   esp,0xfffffff0
       mov   .alg_ptr,esp
       sub   esp,4
;****************** delta computng zone **************
;+++++++++ first zone
       mov	bx,.y2	     ; calc delta12
       sub	bx,.y1
       jnz	.dx12_make
       mov	ecx,7
     @@:
       push	dword 0
       loop	@b
       jmp	.dx12_done
  .dx12_make:


       mov	ax,.x2
       sub	ax,.x1
       cwde
       movsx	ebx,bx
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;	mov	 .dx12,eax
       push	 eax

if  0  ; Ext=SSE
       movd	 mm0,.col1r    ; 2 words  r, g
       pxor	 mm1,mm1
       punpcklwd mm0,mm1
       cvtpi2ps  xmm0,mm0
       movlhps	 xmm0,xmm0
       movd	 mm0,.col1g    ; 2 words  b, z
       punpcklwd mm0,mm1
       cvtpi2ps  xmm0,mm0
       ; xmm0=four float double words
       divss	 xmm0,.pack3
       ;convert and insert mm0 to lower xmm1	 ..
end if

       mov	ax,word .tex_x2
       sub	ax,word .tex_x1
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .tex_dx12r,eax
       push	  eax

       mov	  ax,word .tex_y2
       sub	  ax,word .tex_y1
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .tex_dx12,eax
       push	eax

       mov	ax,word .z2
       sub	ax,word .z1
       cwde
       shl	eax,CATMULL_SHIFT
       cdq
       idiv	ebx
 ;	mov	 .dz12,eax
       push	eax	  ; .dza12

       mov	ax,word .col2r
       sub	ax,word .col1r
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;	mov	 .dc12r,eax
       push	  eax

       mov	  ax,word .col2g
       sub	  ax,word .col1g
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;	mov	 .dc12g,eax
       push	eax

       mov	ax,word .col2b	       ;;---
       sub	ax,word .col1b
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .dc12b,eax
       push	eax

;+++++++++++++++++ second zone +++++++++++++
   .dx12_done:
       sub	esp,4
       mov	bx,.y3	     ; calc delta23
       sub	bx,.y2
       jnz	.dx23_make
       mov	ecx,7
    @@:
       push	dword 0
       loop	@b
       jmp	.dx23_done

  .dx23_make:
       mov	ax,.x3
       sub	ax,.x2
       cwde
       movsx	ebx,bx
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;	mov	 .dx23,eax
       push	 eax

       mov	ax,word .tex_x3
       sub	ax,word .tex_x2
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .tex_dx23,eax
       push	  eax

       mov	  ax,word .tex_y3
       sub	  ax,word .tex_y2
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .tex_dy23,eax
       push	eax

       mov	ax,word .z3
       sub	ax,word .z2
       cwde				   ;
       shl	eax,CATMULL_SHIFT	   ;  2222222
       cdq				   ;  2     2
       idiv	ebx			   ;	    2
;	mov	 .dz23,eax		   ;	   2
       push	eax	  ; .dza12	   ;	  2
					   ;	 2
       mov	ax,word .col3r		   ;	2
       sub	ax,word .col2r		   ;   2222222
       cwde				   ;  second delta
       shl	eax,ROUND		   ;
       cdq				   ;
       idiv	ebx			   ;
;	mov	 .dc23r,eax		    ;
       push	  eax

       mov	  ax,word .col3g
       sub	  ax,word .col2g
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .dc23g,eax
       push	eax

       mov	ax,word .col3b	       ;;---
       sub	ax,word .col2b
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .dc23b,eax
       push	eax

   .dx23_done:
;++++++++++++++++++thrid zone++++++++++++++++++++++++
       sub	esp,4
       mov	bx,.y3	     ; calc delta13
       sub	bx,.y1
       jnz	.dx13_make
       mov	ecx,7
     @@:
       push	dword 0
       loop	@b
       jmp	.dx13_done
  .dx13_make:
       mov	ax,.x3
       sub	ax,.x1
       cwde
       movsx	ebx,bx
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .dx13,eax
       push	 eax

       mov	ax,word .tex_x3 	   ; triangle b
       sub	ax,word .tex_x1
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .tex_dx13r,eax
       push	  eax

       mov	  ax,word .tex_y3
       sub	  ax,word .tex_y1
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .tex_dy13,eax
       push	eax

       mov	ax,word .z3
       sub	ax,word .z1	       ;    333333333
       cwde			       ;   3	    3
       shl	eax,CATMULL_SHIFT      ;	    3
       cdq			       ;	    3
       idiv	ebx		       ;	    3
;	mov	 .dz13,eax	       ;	    3
       push	eax	  ; .dza12     ;	    3
				       ;	    3
       mov	ax,word .col3r	       ;    3333333333
       sub	ax,word .col1r	       ;	    3
       cwde			       ;	    3
       shl	eax,ROUND	       ;	    3
       cdq			       ;	    3
       idiv	ebx		       ;	    3
  ;    mov	.dc13r,eax	       ;    3	    3
       push	  eax		      ;     33333333

       mov	  ax,word .col3g
       sub	  ax,word .col1g
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
 ;	mov	 .dc13g,eax
       push	eax

       mov	ax,word .col3b	       ;;---
       sub	ax,word .col1b
       cwde
       shl	eax,ROUND
       cdq
       idiv	ebx
;	mov	 .dc13b,eax
       push	eax

   .dx13_done:

; <<<<<<<  ::delta zone end+++++++++++++++++++++ >>>>>>>>
       mov	edx,esp
    ;	add	 edx,96
       mov	edx,.alg_ptr
       sub	esp,80	 ;(12*4)

       movsx	eax,.x1 		   ; eax - cur x1
       movsx	ecx,word .z1
       movzx	edi,word .col1r
       movzx	esi,word .col1g
       shl	eax,ROUND		   ; ebx - cur x2
       shl	ecx,CATMULL_SHIFT
       shl	edi,ROUND
       shl	esi,ROUND
       mov	ebx,eax
       mov	.zz1,ecx
       mov	.zz2,ecx
       mov	.cur1r,edi
       mov	.cur2r,edi
       mov	.cur1g,esi
       mov	.cur2g,esi

       movzx	ecx,word .col1b
       movzx	edi,word .tex_x1
       movzx	esi,word .tex_y1
       shl	ecx,ROUND
       shl	edi,ROUND
       shl	esi,ROUND
       mov	.cur1b,ecx
       mov	.cur2b,ecx
       mov	.scan_x1,edi
       mov	.scan_x2,edi
       mov	.scan_y1,esi
       mov	.scan_y2,esi

       mov	cx,.y1
       cmp	cx,.y2
       jge	.f_loop1_end
    .f_loop_1:

       pushad

    ;	push	 word .y_max
       push	dword .y_min
       push	.tex_ptr
       push	.scr_buff
       push	.z_ptr
       push	cx

       movdqa	xmm0,.cur2b
       movq	xmm1,.scan_y2
       movdqa	xmm2,.cur1b
       movq	xmm3,.scan_y1

       sub	esp,48
       movq	[esp+40],xmm1
       movdqu	[esp+24],xmm0
       movq	[esp+16],xmm3
       movdqu	[esp],xmm2

       sar	eax,ROUND
       sar	ebx,ROUND
       call	horizontal_tex_grd_line

      ; pop	 ebp ebx eax
       popad

       movaps	xmm0,.cur1b
       movaps	xmm1,.cur2b
       movq	xmm2,.scan_y1
       movq	xmm3,.scan_y2
       paddd	xmm0,.dc13b
       paddd	xmm1,.dc12b
       paddd	xmm2,.tex_dy13
       paddd	xmm3,.tex_dy12
       movaps	.cur1b,xmm0
       movaps	.cur2b,xmm1
       movq	.scan_y1,xmm2
       movq	.scan_y2,xmm3
       add	eax,.dx13
       add	ebx,.dx12
       add	cx,1
       cmp	cx,.y2
       jl      .f_loop_1
 .f_loop1_end:
       mov	cx,.y2
       cmp	cx,.y3
       jge	.end   ;;.f_loop2_end

       movsx	ebx,word .z2
       movzx	edi,word .col2r
       movzx	esi,word .col2g
       shl	ebx,CATMULL_SHIFT
       shl	edi,ROUND
       shl	esi,ROUND
       mov	.zz2,ebx
       mov	.cur2r,edi
       mov	.cur2g,esi

       movzx	ebx,word .col2b
       movzx	edi,word .tex_x2
       movzx	esi,word .tex_y2
       shl	ebx,ROUND
       shl	edi,ROUND
       shl	esi,ROUND
       mov	.cur2b,ebx
       mov	.scan_x2,edi
       mov	.scan_y2,esi

       movsx	ebx,.x2 		   ; eax - cur x1
       shl	ebx,ROUND		   ; ebx - cur x2

  .f_loop_2:
       pushad
;	push	 word .y_max
       push	dword .y_min
       push	.tex_ptr
       push	.scr_buff
       push	.z_ptr
       push	cx

       movdqa	xmm0,.cur2b
       movq	xmm1,.scan_y2
       movdqa	xmm2,.cur1b
       movq	xmm3,.scan_y1

       sub	esp,48
       movq	[esp+40],xmm1
       movdqu	[esp+24],xmm0
       movq	[esp+16],xmm3
       movdqu	[esp],xmm2

       sar	eax,ROUND
       sar	ebx,ROUND
       call	horizontal_tex_grd_line

       popad

       movaps	xmm0,.cur1b
       movaps	xmm1,.cur2b
       movq	xmm2,.scan_y1
       movq	xmm3,.scan_y2
       paddd	xmm0,.dc13b
       paddd	xmm1,.dc23b
       paddd	xmm2,.tex_dy13
       paddd	xmm3,.tex_dy23
       movaps	.cur1b,xmm0
       movaps	.cur2b,xmm1
       movq	.scan_y1,xmm2
       movq	.scan_y2,xmm3

       add	eax,.dx13
       add	ebx,.dx23
       add	cx,1
       cmp	cx,.y3
       jl	.f_loop_2

   .end:
       mov	esp,ebp
ret 40
horizontal_tex_grd_line:
;in:
; eax : x1, ebx : x2
.y_max	  equ [ebp+68]
.y_min	  equ [ebp+66]
.tex_ptr  equ [ebp+62]
.screen   equ [ebp+58]
.z_buffer equ [ebp+54]
.y	  equ [ebp+52]

.tex_x2 equ [ebp+48]
.tex_y2 equ [ebp+44]
.z2	equ [ebp+40]
.r2	equ [ebp+36]
.g2	equ [ebp+32]
.b2	equ [ebp+28]

.tex_x1 equ [ebp+24]
.tex_y1 equ [ebp+20]
.z1	equ [ebp+16]
.r1	equ [ebp+12]
.g1	equ [ebp+8]
.b1	equ [ebp+4]

.x1	equ   word[ebp-2]
.x2	equ   word[ebp-4]
.dz	equ  dword[ebp-8]
.db	equ	  [ebp-12]
.dg	equ  dword[ebp-16]
.dr	equ	  [ebp-20]
.dtex_x equ  dword[ebp-24]
.dtex_y equ	  [ebp-28]

.c_tx	equ	  [ebp-32]
.c_ty	equ	  [ebp-36]


	mov	ebp,esp
  ;	 sub	 esp,30

	mov	cx,word .y
	cmp	cx,.y_min
	jl	.quit_l

	cmp	cx,.y_max ;[yres_var]  ;SIZE_Y
	jge	.quit_l

	cmp	ax,bx
	je	.quit_l
	jl	@f

	xchg	eax,ebx

       movups  xmm0,.b1
       movups  xmm1,.b2
       movups  .b1,xmm1
       movups  .b2,xmm0
       movq    mm4,.tex_y1    ; x, z
       movq    mm5,.tex_y2
       movq    .tex_y1,mm5
       movq    .tex_y2,mm4

    @@:
	or	bx,bx
	jle	.quit_l
	cmp	ax,[xres_var]  ;SIZE_X
	jge	.quit_l

	push	ax
	push	bx

	mov	eax,.z2 	   ; delta zone************
	sub	eax,.z1
	cdq
	mov	bx,.x2
	sub	bx,.x1
	movsx	ebx,bx
	idiv	ebx
	push	eax  ; .dz

	mov	eax,.b2
	sub	eax,.b1
	cdq
	idiv	ebx
	push	eax  ; .db

	mov	eax,.g2
	sub	eax,.g1
	cdq
	idiv	ebx
	push	eax  ; .dg

	mov	eax,.r2
	sub	eax,.r1
	cdq
	idiv	ebx
	push	eax  ; .dr

	mov	eax,.tex_x2
	sub	eax,.tex_x1
	cdq
	idiv	ebx
	push	eax  ; .dtex_x

	mov	eax,.tex_y2
	sub	eax,.tex_y1
	cdq
	idiv	ebx
	push	eax  ; .dtey_x

	cmp	.x1,0
	jg	@f

	mov	eax,.dz     ; clipping
	movsx	ebx,.x1
	neg	ebx
	imul	ebx
	add	.z1,eax
	mov	.x1,0

	mov    eax,.dr
	imul   ebx
	add    .r1,eax

	mov    eax,.dg
	imul   ebx
	add    .g1,eax

	mov    eax,.db
	imul   ebx
	add    .b1,eax

	mov    eax,.dtex_x
	imul   ebx
	add    .tex_x1,eax

	mov    eax,.dtex_y
	imul   ebx
	add    .tex_y1,eax
   @@:
	movzx	  edx,[xres_var]  ;SIZE_X
	cmp	  .x2,dx
	jl	  @f
	mov	  .x2,dx
    @@:
; calc line addres begin in screen and Z buffer
	movsx	  eax,word .y
	mul	  edx
	movsx	  edx,.x1
	add	  eax,edx

	mov	  esi,eax
	shl	  esi,2
	add	  esi,.z_buffer

	lea	  eax,[eax*4]
	mov	  edi,.screen
	add	  edi,eax

	mov	  cx,.x2
	sub	  cx,.x1
	movzx	  ecx,cx

; init current variables
	push	  dword .tex_x1
	push	  dword .tex_y1

	movdqu	  xmm4,.b1  ; lo -> hi b, g, r, z
	movdqu	  xmm6,.dr  ;.tex_y1
	pxor	  xmm0,xmm0
	pshufd	  xmm4,xmm4,11000110b
	mov	  ebx,.z1
      .ddraw:
	cmp	  ebx,dword[esi]
	jge	  @f
	mov	  eax,.c_ty
	mov	  edx,.c_tx   ; calc texture pixel mem addres
	shr	  eax,ROUND
	shr	  edx,ROUND
	shl	  eax,TEX_SHIFT
	add	  eax,edx
	and	  eax,TEXTURE_SIZE   ; cutting
	shl	  eax,2
	add	  eax,.tex_ptr
	mov	  dword[esi],ebx

	movd	  xmm1,[eax]
	punpcklbw xmm1,xmm0
	movdqa	  xmm3,xmm4  ;.cr     ; lo -> r,g
	psrld	  xmm3,ROUND  ;
	packssdw  xmm3,xmm3
	pmullw	  xmm1,xmm3
	psrlw	  xmm1,8
	packuswb  xmm1,xmm0
	movd	  [edi],xmm1
     @@:
       movq	  mm1,qword .c_ty
       paddd	  xmm4,xmm6 ; r, g, b += dr, dg, db
       add	  ebx,.dz
       paddd	  mm1,qword .dtex_y
       add	  edi,4
       add	  esi,4
       movq	  qword .c_ty,mm1

       sub	ecx,1
       jnz	.ddraw

  .quit_l:
	mov	esp,ebp
ret 42+20+4  ; horizontal line

